JavaScript Grid: Cell Renderer
The job of the grid is to lay out the cells. By default the grid will create the cell values using simple text. If you want more complex HTML inside the cells you can achieve this using cell renderers.
Simple Cell Renderer
Below is a simple example of cell renderer class:
class TotalValueRenderer {
// gets called once before the renderer is used
init(params) {
// create the cell
this.eGui = document.createElement('div');
this.eGui.innerHTML = `
<span>
<span class="my-value"></span>
<button class="btn-simple">Push For Total</button>
</span>
`;
// get references to the elements we want
this.eButton = this.eGui.querySelector('.btn-simple');
this.eValue = this.eGui.querySelector('.my-value');
// set value into cell
this.cellValue = this.getValueToDisplay(params);
this.eValue.innerHTML = this.cellValue;
// add event listener to button
this.eventListener = () => alert(`${this.cellValue} medals won!`);
this.eButton.addEventListener('click', this.eventListener);
}
getGui() {
return this.eGui;
}
// gets called whenever the cell refreshes
refresh(params) {
// set value into cell again
this.cellValue = this.getValueToDisplay(params);
this.eValue.innerHTML = this.cellValue;
// return true to tell the grid we refreshed successfully
return true;
}
// gets called when the cell is removed from the grid
destroy() {
// do cleanup, remove event listener from button
if (this.eButton) {
// check that the button element exists as destroy() can be called before getGui()
this.eButton.removeEventListener('click', this.eventListener);
}
}
getValueToDisplay(params) {
return params.valueFormatted ? params.valueFormatted : params.value;
}
}
Simple Cell Renderer Example
The example below shows a simple cell renderer in action. It uses a cell renderer to render a hash (#
) symbol for each medal won
(instead of the medal count), and the MedalCellRenderer
defined in the code snippet above for the Total
column:
Cell Renderer Component
The interface for the cell renderer component is as follows:
interface ICellRendererComp {
// Optional - Params for rendering. The same params that are passed to the cellRenderer function.
init?(params: ICellRendererParams): void;
// Mandatory - Return the DOM element of the component, this is what the grid puts into the cell
getGui(): HTMLElement;
// Optional - Gets called once by grid after rendering is finished - if your renderer needs to do any cleanup,
// do it here
destroy?(): void;
// Mandatory - Get the cell to refresh. Return true if the refresh succeeded, otherwise return false.
// If you return false, the grid will remove the component from the DOM and create
// a new component in its place with the new values.
refresh(params: ICellRendererParams): boolean;
}
The interface for the cell renderer parameters is as follows:
interface ICellRendererParams {
value: any, // value to be rendered
valueFormatted: any, // value to be rendered formatted
getValue: () => any, // convenience function to get most recent up to date value
setValue: (value: any) => void, // convenience to set the value
formatValue: (value: any) => any, // convenience to format a value using the column's formatter
data: any, // the row's data
node: RowNode, // row node
colDef: ColDef, // the cell's column definition
column: Column, // the cell's column
rowIndex: number, // the current index of the row (this changes after filter and sort)
api: GridApi, // the grid API
eGridCell: HTMLElement, // the grid's cell, a DOM div element
eParentOfValue: HTMLElement, // the parent DOM item for the cell renderer, same as eGridCell unless using checkbox selection
columnApi: ColumnApi, // grid column API
context: any, // the grid's context
refreshCell: () => void // convenience function to refresh the cell
registerRowDragger: (rowDraggerElement: HTMLElement) => void; // convenience function to register a DOM element as Row Dragger
}
Registering Cell Renderers with Columns
See the section registering custom components for details on registering and using custom cell renderers.
Component Refresh
Component refresh needs a bit more explanation. Here we go through some of the finer details.
Events Causing Refresh
The grid can refresh the data in the browser, but not every refresh / redraw of the grid results in the refresh method of your cell renderer getting called. The following items are those that do cause refresh to be called:
- Calling
rowNode.setDataValue(colKey, value)
to set a value directly onto therowNode
. This is the preferred API way to change one value from outside of the grid. - When editing a cell and editing is stopped, so that cell displays new value after editing.
- Calling
api.refreshCells()
to inform grid data has changed (see Refresh).
If any of the above occur and the grid confirms the data has changed via Change Detection, then the refresh()
method will be called.
The following will not result in the cell renderer's refresh method being called:
- Calling
rowNode.setData(data)
to set new data into arowNode
. When you set the data for the whole row, the whole row in the DOM is recreated again from scratch. - Scrolling the grid vertically causes columns (and their containing cells) to be removed and inserted due to column virtualisation.
All of the above will result in the component being destroyed and recreated. ### Grid vs Component Refresh
The refresh method returns back a boolean value. If you do not want to handle the refresh in the cell renderer, just return back false
from an otherwise empty method. This will indicate to the grid that you did not refresh and the grid will instead destroy the component and create another instance of your component from scratch instead.
Grid vs Component Refresh
The refresh method returns back a boolean value. If you do not want to handle the refresh in the cell renderer, just return back false
from an otherwise empty method. This will indicate to the grid that you did not refresh and the grid will instead destroy the component and create another instance of your component from scratch instead.
Change Detection
As mentioned in the section on Change Detection, the refresh of the cell will not take place if the value getting rendered has not changed.
Cell Renderer Component Lifecycle
The lifecycle of the cell renderer is as follows:
new
is called on the class.init()
is called once.getGui()
is called 0 or 1 times (destroy
could get called first, i.e. when scrolling quickly)refresh()
is called 0...n times (i.e. it may never be called, or called multiple times)destroy()
is called once.
In other words, new()
, init()
and destroy()
are always called exactly once. getGui()
will typically get called once unless destroy()
is called first. refresh()
is optionally called multiple times.
When implementing destroy()
it is important to check that any elements created in getGui()
exist, as when scrolling quickly destroy()
can get called first. Calling getGui()
unnecessarily would negatively affect scroll performance.
If you are doing refresh()
, remember that getGui()
is only called once (assuming the cell renderer hasn't been destroyed first), so be sure to update the existing GUI in your refresh, do not think that the grid is going to call getGui()
again to get a new version of the GUI.
Cell Rendering Flow
The diagram below (which is taken from the section Value Getters & Formatters) summarises the steps the grid takes while working out what to render and how to render.
In short, a value is prepared. The value comes using either the colDef.field
or the colDef.valueGetter
. The value is also optionally passed through a colDef.valueFormatter
if it exists. Then the value is finally placed into the DOM, either directly, or by using the chosen colDef.cellRenderer
.
Complementing Cell Renderer Params
On top of the parameters provided by the grid, you can also provide your own parameters. This is useful if you want to 'configure' your cell renderer. For example, you might have a cell renderer for formatting currency but you need to provide what currency for your cell renderer to use.
Provide params to a cell renderer using the colDef option cellRendererParams
.
// define cellRenderer to be reused
const myCellRenderer = params => `<span style="color: ${params.color}">${params.value}</span>`;
// use with a colour
colDef.cellRenderer = myCellRenderer;
colDef.cellRendererParams = {
color: 'guinnessBlack'
}
// use with another colour
colDef.cellRenderer = myCellRenderer;
colDef.cellRendererParams = {
color: 'irishGreen'
}
Data in Cell Renderers
Sometimes the data
property in the parameters given to a cell renderer might not be populated. This can happen for
example when using row grouping (where the row node has aggData
and groupData
instead of data
), or when rows are
being loaded in the Infinite Row Model and do not yet have data. It is best to check that data
does exist before accessing it in your cell renderer, for example:
colDef.cellRenderer = params => {
// check the data exists, to avoid error
if (params.data) {
// data exists, so we can access it
return `**${params.data.theBoldValue}**`;
}
// when we return null, the grid will display a blank cell
return null;
};
Cell Renderer Function
Instead of using a component, it's possible to use a simple function for a cell renderer. The function takes the same parameters as the cell renderer init
method in the component variant. The function should return back either a) a string of HTML or b) a DOM object.
Use the function variant of a cell renderer if you have no refresh or cleanup requirements (ie you don't need to implement the refresh or destroy functions).
Below are some simple examples of cell renderers provided as simple functions:
// put the value in bold
colDef.cellRenderer = params => `**${params.value.toUpperCase()}**`;
// put a tooltip on the value
colDef.cellRenderer = params => `<span title="the tooltip">${params.value}</span>`;
// create a DOM object
colDef.cellRenderer = params => {
const eDiv = document.createElement('div');
eDiv.innerHTML = '<span class="my-css-class"><button class="btn-simple">Push Me</button></span>';
const eButton = eDiv.querySelectorAll('.btn-simple')[0];
eButton.addEventListener('click', () => {
console.log('button was clicked!!');
});
return eDiv;
}
You might be wondering how the grid knows if you have provided a cell renderer component class or a simple function, as JavaScript uses functions to implement classes. The answer is the grid looks for the getGui() method in the prototype of the function (the only mandatory method in the cell renderer interface). If the getGui() method exists, it assumes a component, otherwise it assumes a function.
Complex Cell Renderer Example
The example below shows five columns formatted, demonstrating each of the methods above.
- 'Month' column uses
cellStyle
to format each cell in the column with the same style. - 'Max Temp' and 'Min Temp' columns uses the Function method to format each cell in the column with the same style.
- 'Days of Air Frost' column uses the Component method to format each cell in the column with the same style
- 'Days Sunshine' and 'Rainfall (10mm)' use simple functions to display icons.
Accessing Cell Renderer Instances
After the grid has created an instance of a cell renderer for a cell it is possible to access that instance. This is useful if you want to call a method that you provide on the cell renderer that has nothing to do with the operation of the grid. Accessing cell renderers is done using the grid API getCellRendererInstances(params)
.
// function takes params to identify which cells and returns back a list of cell renderers
function getCellRendererInstances(params: GetCellRendererInstancesParams): ICellRendererComp[];
// params object for the above
interface GetCellRendererInstancesParams {
// an optional list of row nodes
rowNodes?: RowNode[];
// an optional list of columns
columns?: (string | Column)[];
}
An example of getting the cell renderer for exactly one cell is as follows:
// example - get cell renderer for first row and column 'gold'
const firstRowNode = gridOptions.api.getDisplayedRowAtIndex(0);
const params = { columns: ['gold'], rowNodes: [firstRowNode] };
const instances = gridOptions.api.getCellRendererInstances(params);
if (instances.length > 0) {
// got it, user must be scrolled so that it exists
const instance = instances[0];
}
Not that this method will only return instances of the cell renderer that exists. Due to row and column virtualisation, renderers will only exists for the user can actually see due to horizontal and vertical scrolling.
The example below demonstrates custom methods on cell renderers called by the application. The following can be noted:
- The medal columns are all using the user defined
MedalCellRenderer
. The cell renderer has an arbitrary methodmedalUserFunction()
which prints some data to the console. - The Gold method executes a method on all instances of the cell renderer in the gold column.
- The First Row Gold method executes a method on the gold cell of the first row only. Note that the
getCellRendererInstances()
method will return nothing if the grid is scrolled past the first row. - The All Cells method executes a method on all instances of all cell renderers.
If your are using a framework component (detailed below), then the returned object is a wrapper and you can get the underlying cell renderer using getFrameworkComponentInstance()
// example - get cell renderer for first row and column 'gold'
const firstRowNode = gridOptions.api.getDisplayedRowAtIndex(0);
const params = { columns: ['gold'], rowNodes: [firstRowNode] };
const instances = gridOptions.api.getCellRendererInstances(params);
if (instances.length > 0) {
// got it, user must be scrolled so that it exists
const wrapperInstance = instances[0];
const frameworkInstance = wrapperInstance.getFrameworkComponentInstance();
}
- Cell Renderer
- Simple Cell Renderer
- Simple Cell Renderer Example
- Cell Renderer Component
- Cell Renderer Component
- Cell Renderer Component
- Cell Renderer Component
- Registering Cell Renderers with Columns
- Component Refresh
- Events Causing Refresh
- Grid vs Component Refresh
- Events Causing Refresh
- Grid vs Component Refresh
- Events Causing Refresh
- Grid vs Component Refresh
- Events Causing Refresh
- Grid vs Component Refresh
- Change Detection
- Cell Renderer Component Lifecycle
- Cell Renderer Component Lifecycle
- Cell Renderer Component Lifecycle
- Cell Renderer Component Lifecycle
- Cell Rendering Flow
- Complementing Cell Renderer Params
- Data in Cell Renderers
- Cell Renderer Function
- Cell Renderer Function
- Cell Renderer Function
- Cell Renderer Function
- Complex Cell Renderer Example
- Accessing Cell Renderer Instances
- Example: Rendering using more complex Components
- Example: Rendering using more complex Components
- Example: Rendering using more complex Components
- Example: Rendering using nested Modules

React Grid: Cell Renderer
The job of the grid is to lay out the cells. By default the grid will create the cell values using simple text. If you want more complex HTML inside the cells you can achieve this using cell renderers.
Simple Cell Renderer
Below is a simple example of cell renderer as a Hook:
export default props => {
const cellValue = props.valueFormatted ? props.valueFormatted : props.value;
const buttonClicked = () => {
alert(`${cellValue} medals won!`)
}
return (
<span>
<span>{cellValue}</span>
<button onClick={() => buttonClicked()}>Push For Total</button>
</span>
);
}
And here is the same example as a Class-based Component:
export default class TotalValueRenderer extends Component {
constructor(props) {
super(props);
this.state = {
cellValue: TotalValueRenderer.getValueToDisplay(props)
}
}
// update cellValue when the cell's props are updated
static getDerivedStateFromProps(nextProps) {
return {
cellValue: TotalValueRenderer.getValueToDisplay(nextProps)
};
}
buttonClicked() {
alert(`${this.state.cellValue} medals won!`)
}
render() {
return (
<span>
<span>{this.state.cellValue}</span>
<button onClick={() => this.buttonClicked()}>Push For Total</button>
</span>
);
}
static getValueToDisplay(params) {
return params.valueFormatted ? params.valueFormatted : params.value;
}
};
Simple Cell Renderer Example
The example below shows a simple cell renderer in action. It uses a cell renderer to render a hash (#
) symbol for each medal won
(instead of the medal count), and the MedalCellRenderer
defined in the code snippet above for the Total
column:
Cell Renderer Component
When a React component is instantiated the grid will make the grid APIs, a number of utility methods as well as the cell &
row values available to you via props
.
The interface for values available on both the initial props
value, as well as on futures props
updates or subsequent refresh
calls
(see below for details on refresh
) are as follows:
interface ICellRendererParams {
value: any, // value to be rendered
valueFormatted: any, // value to be rendered formatted
getValue: () => any, // convenience function to get most recent up to date value
setValue: (value: any) => void, // convenience to set the value
formatValue: (value: any) => any, // convenience to format a value using the column's formatter
data: any, // the row's data
node: RowNode, // row node
colDef: ColDef, // the cell's column definition
column: Column, // the cell's column
rowIndex: number, // the current index of the row (this changes after filter and sort)
api: GridApi, // the grid API
eGridCell: HTMLElement, // the grid's cell, a DOM div element
eParentOfValue: HTMLElement, // the parent DOM item for the cell renderer, same as eGridCell unless using checkbox selection
columnApi: ColumnApi, // grid column API
context: any, // the grid's context
refreshCell: () => void // convenience function to refresh the cell
registerRowDragger: (rowDraggerElement: HTMLElement) => void; // convenience function to register a DOM element as Row Dragger
}
Registering Cell Renderers with Columns
See the section registering custom components for details on registering and using custom cell renderers.
Component Refresh
Component refresh needs a bit more explanation. Here we go through some of the finer details.
Events Causing Refresh
When the grid can refresh a cell (instead of replacing it altogether) then the update can occur in one of two ways:
- A component will have it's props refreshed, with all corresponding lifecycle methods called (i.e.
componentWillReceiveProps
,getDerivedStateFromProps
) - A
refresh
method that you implement will be called
If you provide a refresh
method then this method will be called over the component's props being refreshed.
Note that if you're using Hooks for a Cell Renderer and decide to implement the refresh
method then you'll need to expose it with
forwardRef
& useImperativeHandle
. Please refer to the Hook documentation (or the examples on this page) for more information.
In the context of "refresh" being referenced from here on then it'll refer to either of the mechanisms above, whichever you choose to implement.
The grid can refresh the data in the browser, but not every refresh / redraw of the grid results in the refresh method of your cell renderer getting called, or for props to be updated.
The following items are those that do cause refresh to be called:
- Calling
rowNode.setDataValue(colKey, value)
to set a value directly onto therowNode
. This is the preferred API way to change one value from outside of the grid. - When editing a cell and editing is stopped, so that cell displays new value after editing.
- Calling
api.refreshCells()
to inform grid data has changed (see Refresh). - Bound
rowData
changes andimmutableData
is set (see Immutable Data).
If any of the above occur and the grid confirms the data has changed via Change Detection, then the refresh()
method will be called.
The following will not result in the cell renderer's refresh method being called:
- Calling
rowNode.setData(data)
to set new data into arowNode
. When you set the data for the whole row, the whole row in the DOM is recreated again from scratch. - Scrolling the grid vertically causes columns (and their containing cells) to be removed and inserted due to column virtualisation.
All of the above will result in the component being destroyed and recreated.
If the grid cannot safely determine a given row then cell components will always be replaced, instead of refreshed - as such we strongly encourage Immutable Data be used whenever possible.
Doing so will allow AG Grid to intelligently determine which cells have changed in a given update and only refresh those cells.
Using Immutable Data is analogous to providing a key
to an array of components in React - it allows for cells to be refreshed (if possible) instead
of being replaced.
Grid vs Component Refresh
If you choose to implement the refresh
method, then note that this method returns back a boolean value. If you do not
want to handle the refresh in the cell renderer, just return back false
from an otherwise empty method. This will
indicate to the grid that you did not refresh and the grid will instead destroy the component and create another instance of your component from scratch instead.
Change Detection
As mentioned in the section on Change Detection, the refresh of the cell will not take place if the value getting rendered has not changed.
Cell Renderer Component Lifecycle
The lifecycle of the cell renderer is as follows:
- The component will be instantiated.
- The component's GUI will be inserted into the grid 0 or 1 times (the component could get destroyed first, i.e. when scrolling quickly).
- The component's props are updated, or
refresh()
is called, 0...n times (i.e. it may never be called, or called multiple times). - The component is destroyed once.
In other words, component instantiation and destruction are always called exactly once. The component's GUI will
typically get rendered once unless the component is destroyed first. The component's props are updated/refresh()
is optionally called multiple times.
Cell Rendering Flow
The diagram below (which is taken from the section Value Getters & Formatters) summarises the steps the grid takes while working out what to render and how to render.
In short, a value is prepared. The value comes using either the colDef.field
or the colDef.valueGetter
. The value is also optionally passed through a colDef.valueFormatter
if it exists. Then the value is finally placed into the DOM, either directly, or by using the chosen colDef.cellRenderer
.
Complementing Cell Renderer Params
On top of the parameters provided by the grid, you can also provide your own parameters. This is useful if you want to 'configure' your cell renderer. For example, you might have a cell renderer for formatting currency but you need to provide what currency for your cell renderer to use.
Provide params to a cell renderer using the colDef option cellRendererParams
.
// define cellRenderer to be reused
const ColourCellRenderer = props => <span style={{color: props.color}}>{props.value}</span>;
const GridExample = () => {
// other properties & methods
frameworkComponents = {
'colourCellRenderer': ColourCellRenderer
};
return (
<div className="ag-theme-alpine">
<AgGridReact
frameworkComponents={frameworkComponents}
...other properties>
<AgGridColumn headerName="Colour 1" field="value" cellRenderer="colourCellRenderer" cellRendererParams={{ color: 'guinnessBlack' }} />
<AgGridColumn headerName="Colour 2" field="value" cellRenderer="colourCellRenderer" cellRendererParams={{ color: 'irishGreen' }} />
</AgGridReact>
</div>
);
};
Data in Cell Renderers
Sometimes the data
property in the parameters given to a cell renderer might not be populated. This can happen for
example when using row grouping (where the row node has aggData
and groupData
instead of data
), or when rows are
being loaded in the Infinite Row Model and do not yet have data. It is best to check that data
does exist before accessing it in your cell renderer, for example:
// define cellRenderer to be reused
const CellRenderer = props => <span>{props.data && props.data.theBoldValue}</span>;
Cell Renderer Function
Instead of using a React component, it's possible to use a simple function for a cell renderer.
This is probably most useful if you have a simple String value to render and want to avoid the overhead of an actual React component.
In the example below we're outputting a simple string value that depends on the cell value:
const GridExample = () => {
// other properties & methods
return (
<div className="ag-theme-alpine">
<AgGridReact
...other properties>
<AgGridColumn headerName="Value" field="value" cellRenderer={params => params.value > 1000 ? "LARGE VALUE" : "SMALL VALUE"} />
</AgGridReact>
</div>
);
};
It is also possible to write a JavaScript-based cell renderer function - refer to the docs here for more information
Complex Cell Renderer Example
The example below shows five columns formatted, demonstrating each of the methods above.
- 'Month' column uses
cellStyle
to format each cell in the column with the same style. - 'Max Temp' and 'Min Temp' columns uses the Function method to format each cell in the column with the same style.
- 'Days of Air Frost' column uses the Component method to format each cell in the column with the same style
- 'Days Sunshine' and 'Rainfall (10mm)' use simple functions to display icons.
Accessing Cell Renderer Instances
After the grid has created an instance of a cell renderer for a cell it is possible to access that instance. This is useful if you want to call a method that you provide on the cell renderer that has nothing to do with the operation of the grid. Accessing cell renderers is done using the grid API getCellRendererInstances(params)
.
// function takes params to identify which cells and returns back a list of cell renderers
function getCellRendererInstances(params: GetCellRendererInstancesParams): ICellRendererComp[];
// params object for the above
interface GetCellRendererInstancesParams {
// an optional list of row nodes
rowNodes?: RowNode[];
// an optional list of columns
columns?: (string | Column)[];
}
An example of getting the cell renderer for exactly one cell is as follows:
// example - get cell renderer for first row and column 'gold'
const firstRowNode = gridOptions.api.getDisplayedRowAtIndex(0);
const params = { columns: ['gold'], rowNodes: [firstRowNode] };
const instances = gridOptions.api.getCellRendererInstances(params);
if (instances.length > 0) {
// got it, user must be scrolled so that it exists
const instance = instances[0];
}
Not that this method will only return instances of the cell renderer that exists. Due to row and column virtualisation, renderers will only exists for the user can actually see due to horizontal and vertical scrolling.
The example below demonstrates custom methods on cell renderers called by the application. The following can be noted:
- The medal columns are all using the user defined
MedalCellRenderer
. The cell renderer has an arbitrary methodmedalUserFunction()
which prints some data to the console. - The Gold method executes a method on all instances of the cell renderer in the gold column.
- The First Row Gold method executes a method on the gold cell of the first row only. Note that the
getCellRendererInstances()
method will return nothing if the grid is scrolled past the first row. - The All Cells method executes a method on all instances of all cell renderers.
If your are using a framework component (detailed below), then the returned object is a wrapper and you can get the underlying cell renderer using getFrameworkComponentInstance()
// example - get cell renderer for first row and column 'gold'
const firstRowNode = gridOptions.api.getDisplayedRowAtIndex(0);
const params = { columns: ['gold'], rowNodes: [firstRowNode] };
const instances = gridOptions.api.getCellRendererInstances(params);
if (instances.length > 0) {
// got it, user must be scrolled so that it exists
const wrapperInstance = instances[0];
const frameworkInstance = wrapperInstance.getFrameworkComponentInstance();
}
Example: Rendering using more complex Components
This example illustrates a few different ideas:
- Custom Cell Renderers
- Parent/Child Communication using context
-
Storing the Grid API via the "Grid Ready" event, and using it later
Note that the hook version of this example makes use of useImperativeHandle
to expose methods to the grid (and other components). Please
refer to the hook specific documentation for more information.
- Cell Renderer
- Simple Cell Renderer
- Simple Cell Renderer Example
- Cell Renderer Component
- Cell Renderer Component
- Cell Renderer Component
- Cell Renderer Component
- Registering Cell Renderers with Columns
- Component Refresh
- Events Causing Refresh
- Grid vs Component Refresh
- Events Causing Refresh
- Grid vs Component Refresh
- Events Causing Refresh
- Grid vs Component Refresh
- Events Causing Refresh
- Grid vs Component Refresh
- Change Detection
- Cell Renderer Component Lifecycle
- Cell Renderer Component Lifecycle
- Cell Renderer Component Lifecycle
- Cell Renderer Component Lifecycle
- Cell Rendering Flow
- Complementing Cell Renderer Params
- Data in Cell Renderers
- Cell Renderer Function
- Cell Renderer Function
- Cell Renderer Function
- Cell Renderer Function
- Complex Cell Renderer Example
- Accessing Cell Renderer Instances
- Example: Rendering using more complex Components
- Example: Rendering using more complex Components
- Example: Rendering using more complex Components
- Example: Rendering using nested Modules

Angular Data Grid

Cell Components

angular logo

The example below shows adding images, hyperlinks, and buttons to a cell using Custom Cell Components.

Custom Components

The interface for the Cell Component is as follows:

interface ICellRendererAngularComp {
   // Mandatory - Params for rendering
   agInit(params: ICellRendererParams): void;

   // Mandatory - Return true if you have managed the cell refresh yourself in this method, otherwise return false.
   // If you return false, the grid will remove the component from the DOM and create a new component in its place 
   // with the new values.
   refresh(params: ICellRendererParams): boolean;
}

The Component is provided props containing, amongst other things, the value to be rendered.

class CustomButtonComponent implements ICellRendererAngularComp {
  // ...
  agInit(props: ICellRendererParams): void {
    this.cellValue = props.value;
  }
  // ...

The provided props (interface ICellRendererParams) are:

Note that if Row Selection is enabled, it is recommended to set suppressKeyboardEvent on the column definition to prevent the ␣ Space key from triggering both row selection and toggling the checkbox.

Provided Components

The grid comes with some Cell Components out of the box. These Provided Cell Components cover common some common complex cell rendering requirements.

Selecting Components

The Cell Component for a Column is set via colDef.cellRenderer and can be any of the following types:

  1. String: The name of a registered Cell Component.*
  2. Class: Direct reference to a Cell Component.
  3. Function: A function that returns either an HTML string or DOM element for display.

*If referenced by name then the Cell Component must first be registered.

The code snippet below demonstrates each of these method types.

<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */>
</ag-grid-angular>

this.columnDefs = [
    // 1 - String - The name of a Cell Component registered with the grid.
    {
        field: 'age',
        cellRenderer: 'agGroupCellRenderer',
    },
    // 2 - Class - Provide your own Cell Component directly without registering.
    {
        field: 'sport',
        cellRenderer: MyCustomCellRendererClass,
    },
    // 3 - Function - A function that returns an HTML string or DOM element for display
    {
        field: 'year',
        cellRenderer: params => {
            // put the value in bold
            return 'Value is <b>' + params.value + '</b>';
        }
    }
];

Dynamic Selection

The colDef.cellRendererSelector function allows setting difference Cell Components for different Rows within a Column.

The params passed to cellRendererSelector are the same as those passed to the Cell Renderer Component. Typically the selector will use this to check the rows contents and choose a renderer accordingly.

The result is an object with component and params to use instead of cellRenderer and cellRendererParams.

This following shows the Selector always returning back a Mood Cell Renderer:

cellRendererSelector: params => {
   return {
       component: GenderCellRenderer,
       params: {values: ['Male', 'Female']}
   };
}

However a selector only makes sense when a selection is made. The following demonstrates selecting between Mood and Gender Cell Renderers:

cellRendererSelector: params => {

   const type = params.data.type;

   if (type === 'gender') {
       return {
           component: GenderCellRenderer,
           params: {values: ['Male', 'Female']}
       };
   }

   if (type === 'mood') {
       return {
           component: MoodCellRenderer
       };
   }

   return undefined;
}

Here is a full example.

  • The column 'Value' holds data of different types as shown in the column 'Type' (numbers/genders/moods).
  • colDef.cellRendererSelector is a function that selects the renderer based on the row data.
  • The column 'Rendered Value' show the data rendered applying the component and params specified by colDef.cellRendererSelector

Custom Props

The props passed to the Cell Component can be complimented with custom props. This allows configuring reusable Cell Components - e.g. a component could have buttons that are optionally displayed via additional props.

Compliment props to a cell renderer using the Column Definition attribute cellRendererParams. When provided, these props will be merged with the grid provided props.

// define Cell Component to be reused
@Component({
   selector: 'colour-cell',
   template: `<span [style.colour]="params.color">{{params.value}}</span>`
})
class ColourCellComp implements ICellRendererAngularComp {
   params!: ICellRendererParams;

   agInit(params: ICellRendererParams) {
       this.params = params;
   }

   refresh(params: ICellRendererParams) {
       this.params = params;
       // As we have updated the params we return true to let AG Grid know we have handled the refresh.
       // So AG Grid will not recreate the cell renderer from scratch.
       return true;
   }
}

@Component({
   selector: 'my-app',
   template: `
       <ag-grid-angular
               class="ag-theme-quartz"
               [columnDefs]="columnDefs"
               ...other properties>        
       </ag-grid-angular>`
})
export class AppComponent {
   private columnDefs = [
       {
           headerName: "Colour 1",
           field: "value",
           cellRenderer: ColourCellComp,
           cellRendererParams: {
              color: 'guinnessBlack'
           }
       },
       {
           headerName: "Colour 2",
           field: "value",
           cellRenderer: ColourCellComp,
           cellRendererParams: {
              color: 'irishGreen'
           }
       }
   ];

  //...
}

This example shows rendering an image with and without custom props and using custom props to pass a callback to a button. The Refresh Data button triggers the cell components to refresh by randomising the success data.

Cell Component Function

Instead of using an Angular component, it's possible to use a function for a Cell Component.

This is useful if you have a simple String value to render and want to avoid the overhead of an Angular component.

In the example below we're outputting a string value that depends on the cell value:

@Component({
   selector: 'my-app',
   template: `
       <ag-grid-angular
               [columnDefs]="columnDefs"
               ...other properties>
       </ag-grid-angular>`
})
export class AppComponent {
   private columnDefs = [
       {
           headerName: "Value",
           field: "value",
           cellRenderer: params => params.value > 1000 ? "LARGE VALUE" : "SMALL VALUE"
       }
    ];
    //...
}

It is also possible to write a JavaScript-based Cell Renderer Component - refer to the docs here for more information

Accessing Instances

After the grid has created an instance of a Cell Component for a cell it is possible to access that instance. This is useful if you want to call a method that you provide on the Cell Component that has nothing to do with the operation of the grid. Accessing Cell Components is done using the grid API getCellRendererInstances(params).

An example of getting the Cell Component for exactly one cell is as follows:

// example - get cell renderer for first row and column 'gold'
const firstRowNode = api.getDisplayedRowAtIndex(0);
const params = { columns: ['gold'], rowNodes: [firstRowNode] };
const instances = api.getCellRendererInstances(params);

if (instances.length > 0) {
   // got it, user must be scrolled so that it exists
   const instance = instances[0];
}

Note that this method will only return instances of the Cell Component that exists. Due to Row and Column Virtualisation, Cell Components will only exist for Cells that are within the viewport of the Vertical and Horizontal scrolls.

The example below demonstrates custom methods on Cell Components called by the application. The following can be noted:

  • The medal columns are all using the user defined MedalCellRenderer. The Cell Component has an arbitrary method medalUserFunction() which prints some data to the console.
  • The Gold method executes a method on all instances of the Cell Component in the gold column.
  • The First Row Gold method executes a method on the gold cell of the first row only. Note that the getCellRendererInstances() method will return nothing if the grid is scrolled far past the first row showing row virtualisation in action.
  • The All Cells method executes a method on all instances of all Cell Components.

Dynamic Tooltips

When working with Custom Cell Renderers it is possible to register custom tooltips that are displayed dynamically by using the setTooltip method.

Properties available on the ICellRendererParams<TData = any, TValue = any, TContext = any> interface.

The example below demonstrates a dynamic tooltip being displayed on Cell Components. The following can be noted:

  • The Athlete column uses the shouldDisplayTooltip callback to only display Tooltips when the text is not fully displayed.